//
// @(#)NSLookup.java
//
// @author      Erik C. Thauvin
// @version     1.0, 01/07/99
//
// Copyright (C) 1999 Blue World Communications, Inc. All right reserved.
//
// Blue World Communications grants you ("Licensee") a non-exclusive, royalty
// free, license to use, modify and redistribute this software in source and
// binary code form, provided that i) this copyright notice and license appear
// on all copies of the software; and ii) Licensee does not utilize the software
// in a manner which is disparaging to Blue World Communications.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
// IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
// NON-INFRINGEMENT, ARE HEREBY EXCLUDED. BLUE WORLD COMMUNICATIONS AND ITS
// LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A
// RESULT OF USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES.
// IN NO EVENT WILL BLUE WORLD COMMUNICATIONS OR ITS LICENSORS BE LIABLE FOR ANY
// LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,
// INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF
// LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF
// BLUE WORLD COMMUNICATIONS HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//

import com.blueworld.lassopro.*;
import java.io.*;
import java.net.*;

public class NSLookup extends LassoTagModule
{
	public NSLookup()
	{
		super(); // always a good idea to call the super
	}
	
	public int format( LassoCall lasso, int action )
	{
		int err = ERR_NOERR;
		
		try
		{
			IntValue count = new IntValue();		
			lasso.getTagParamCount(count);
			
			if ( count.intValue() == 1 )
			{
				LassoValue param = new LassoValue();		
				lasso.getTagParam(0, param);
				String lookup = param.name();
				
				InetAddress theAddress = InetAddress.getByName(lookup);
				boolean ip = true;
				
				for (int i = 0; i < lookup.length(); i++)
				{
					char c = lookup.charAt(i);
					if (!Character.isDigit(c))
					{
						if (c != '.')
						{
							ip = false;
							break;
						}
					}
				}
				
				if (ip)
				{
					err = lasso.outputTagData(theAddress.getHostName());

				}
				else
				{
					err = lasso.outputTagData(theAddress.getHostAddress());
				}
			}
		}
		catch(IOException e)
		{
			lasso.setResultMessage(e.toString());
			err = -1;
		}
		
		return err;
	}
	
	public LassoTagInfo[] registerLassoModule()
	{
	
		LassoTagInfo[] info = new LassoTagInfo[1];
		try 
		{
			info[0] = new LassoTagInfo(	"NSLookup", "nslookup", "format", FLAG_SUBSTITUTION, "" );
		} catch (Exception e)
		{ }
		return info;
	}
	
}
