package com.blueworld.lassopro;

/**
 *  Wrapper for a primitive type <code>float</code> or <code>double</code>.
 *  Used for returning decimal values from <code>LassoCall.typeGetDecimal</code> method.
 *
 * 	<pre>
 *	FloatValue f = new FloatValue();
 *	if ( lasso.typeGetDecimal( newQuote, f ) == ERR_NOERR ) {
 *	    lasso.outputTagData( "'AAPL': " + f.toString() );
 *	}
 * 	</pre>
 */
public class FloatValue
{
	private double value;
	{ value = 0.0; }
	
	public FloatValue()
	{;}
	
	public FloatValue(float value)
	{
		this.value = (double)value;
	}
	
	public FloatValue(double value)
	{
		this.value = value;
	}
	/**
	 * Converts the object to a string. 
	 * @overrides toString() method in class Object.
	 */
	public String toString()
	{
		return Double.toString( this.value );
	}

	/**
	 * Returns the value of this <code>FloatValue</code> as a <code>float</code>.
	 */
	public float floatValue()  
	{ 
		return (float)this.value;
	}
	
	/**
	 * Returns the value of this <code>FloatValue</code> as a <code>double</code>.
	 */
	public double doubleValue()  
	{ 
		return this.value;
	}

	public void setFloat( float value )
	{
		setDouble( (double)value );
	}
		
	public void setDouble( double value )
	{
		this.value = value;
	}
	
}


