package com.blueworld.lassopro;

/**
 * <p>Used for outputting messages to the console, file or database.</p>
 */
public final class LassoLogging
{
	private LassoLogging() {;}
	
	/** Used for logging critical errors */
 	public static final int LOG_LEVEL_CRITICAL 	= 0;
 	/** Used for logging warnings and non-critical errors */
	public static final int LOG_LEVEL_WARNING	= 1;
	/** Used for logging non-error and status messages */
	public static final int LOG_LEVEL_DETAIL	= 2;

	/**
	 * Output information to the Lasso console
	 */
	public static final int FLAG_DEST_CONSOLE 	= 1;
	
	/**
	 * Output information to the log file
	 */
	public static final int FLAG_DEST_FILE 		= 2;
	
	/**
	 * Store the information in the error logging table.
	 * The data can be viewed in the Lasso Admin.
	 */
	public static final int FLAG_DEST_DATABASE 	= 4;
	
	
	/**
	 * Changes the system-wide log destination preference
	 * @param msgLevel one of the LOG_LEVEL constants
	 * @param destination one or more logically or'ed FLAG_DEST constants
	 */
	public static native int setDestination( int msgLevel, int destination );
}


