package com.blueworld.naming;

import java.util.List;
import javax.naming.*;

public class LBindingEnumeration
	implements NamingEnumeration
{

	LBindingEnumeration(ContextImpl context, List list)
	{
		ctx = context;
		list = list;
	}

	public boolean hasMore()
	{
		return idx < list.size();
	}

	public Object next()
		throws NamingException
	{
		String name = (String)list.get(idx++);
		Object obj = ctx.lookup(name);
		return new Binding(name, obj, true);
	}

	public boolean hasMoreElements()
	{
		return hasMore();
	}

	public Object nextElement()
	{
		try
		{
			return next();
		}
		catch (Exception e)
		{
			//log
		}
		return null;
	}

	public void close()
	{
	}

	public String toString()
	{
		StringBuffer cb = new StringBuffer();
		cb.append("[LBindingEnumeration");
		for(int i = 0; i < list.size(); i++)
		{
			String name = (String)list.get(i);
			try
			{
				cb.append(" {" + name + ", " + ctx.lookup(name) + "}");
			}
			catch(Exception e)
			{
				cb.append(" {" + name + ", " + e + "}");
			}
		}

		cb.append("]");
		return cb.toString();
	}

	private ContextImpl ctx;
	private List list;
	private int idx;

}
