package com.blueworld.naming;

import java.util.List;
import javax.naming.*;

public class LNameClassEnumeration
	implements NamingEnumeration
{

	LNameClassEnumeration(ContextImpl context, List list)
	{
		_ctx = context;
		_list = list;
	}

	public boolean hasMore()
	{
		return _idx < _list.size();
	}

	public Object next()
		throws NamingException
	{
		String name = (String)_list.get(_idx++);
		Object obj = _ctx.lookup(name);
		if(obj != null)
			return new NameClassPair(name, obj.getClass().getName());
		else
			return new NameClassPair(name, "java.lang.Object");
	}

	public boolean hasMoreElements()
	{
		return hasMore();
	}

	public Object nextElement()
	{
		try
		{
			return next();
		}
		catch (Exception e)
		{
			// log
		}
		return null;
	}

	public void close()
	{
	}

	public String toString()
	{
		StringBuffer cb = new StringBuffer();
		cb.append("[LNameClassEnumeration");
		for(int i = 0; i < _list.size();)
		{
			String name = (String)_list.get(i);
			try
			{
				Object value = _ctx.lookup(name);
				if(value != null)
					cb.append(" {" + name + ", " + value.getClass() + "}");
				else
					cb.append(" {" + name + ", " + null + "}");
				continue;
			}
			catch(Exception e)
			{
				// log
				cb.append(" {" + name + ", " + e + "}");
				i++;
			}
		}

		cb.append("]");
		return cb.toString();
	}

	private ContextImpl _ctx;
	private List _list;
	private int _idx;

}
