package com.blueworld.naming;

import java.util.*;
import javax.naming.NamingException;

public class LocalRegistry
{
	public LocalRegistry()
	{
		entries = new HashMap(8);
	}

	protected LocalRegistry create()
	{
		return new LocalRegistry();
	}

	public Object lookup(String name)
		throws NamingException
	{
		return entries.get(name);
	}

	public void bind(String name, Object obj)
		throws NamingException
	{
		entries.put(name, obj);
	}

	public void unbind(String name)
		throws NamingException
	{
		entries.remove(name);
	}

	public LocalRegistry createSubcontext(String name)
		throws NamingException
	{
		if(entries.get(name) != null)
		{
			throw new NamingException("can't create subcontext: " + name + " " + entries.get(name));
		} else
		{
			LocalRegistry reg = new LocalRegistry();
			entries.put(name, reg);
			return reg;
		}
	}

	public List list()
	{
		return new ArrayList(entries.keySet());
	}

	private HashMap entries;
}
