package com.omnipilot.lassopro;

/**
 *  Wrapper for a primitive type <code>int</code> or <code>long</code>.
 *  Used for returning values from <code>LassoCall</code> methods which in LCAPI 
 *  would require passing parameters of type pointer: <code>int*</code>, 
 *  <code>long*</code> and <code>DescType*</code>.
 *
 * 	<pre>
 *	IntValue outLen = new IntValue();
 *	if ( lasso.arrayGetSize( myArray, outLen ) == ERR_NOERR ) {
 *	    lasso.outputTagData( "Array size: " + outLen.toString() );
 *	}
 * 	</pre>
 */
public class IntValue 
	extends com.blueworld.lassopro.IntValue
{

}
