package com.omnipilot.lassopro;

/**
 * <p>The core of the Lasso Java API v8.0.
 *
 * All the interaction between an LJAPI module and Lasso Professional is achieved 
 * by a means of invoking various methods implemented in this class. 
 * These functions can be used to perform the following tasks:<br> 
 * <ul>
 * <li>register your tags or data sources</li>
 * <li>allocate memory</li>
 * <li>return error messages</li>
 * <li>get tag or parameter information</li> 
 * <li>get client/server environment information</li>
 * <li>output text/data</li>
 * <li>read/set MIME headers</li>
 * <li>access LDML variables</li>
 * <li>interpret/execute arbitrary LDML tags</li>
 * <li>store persistent data</li>
 * <li>check if the user is an administrator</li>
 * <li>perform data source functions</li>
 * <li>safely access multiuser/multithreaded resources</li>
 * </ul>
 * <p>Most methods return the result code - either <code>NOERR</code>
 * if the function succeeds, or an error code indicating there was a problem during this method execution.
 * @see LassoDSModule LassoDSModule
 * @see LassoTagModule LassoTagModule
 * @see LassoErrors LassoErrors
 * 
 */

public class LassoCall 
	extends com.blueworld.lassopro.LassoCall 
{

}
