package com.omnipilot.lassopro;

/**
 * Base class for any datasource module.
 *
 * <code>LassoDSModules</code> are used to manipulate datasources.
 * <code>LassoDSModules</code> are looked up by the datasource names they claim to support.
 * They are instantiated once and used repeatedly by Lasso.
 *
 * <p>Every <code>LassoDSModule</code> must implement {@link LassoJavaModule#registerLassoModule registerLassoModule} 
 * method, and one or more methods with the same signature as {@link #DS_METHOD_PROTOTYPE DS_METHOD_PROTOTYPE}.<br><br>
 *
 * Lasso calls <code>registerLassoModule</code> once at startup to give this
 * module a chance to register its datasource(s). <code>LassoDSModule</code> must then 
 * call {@link #registerDSModule registerDSModule} as many times as there are datasources implemented by this module.
 */
public abstract class LassoDSModule 
	extends com.blueworld.lassopro.LassoDSModule
{
	protected LassoDSModule()
	{
		super();
	}
}
