package com.omnipilot.lassopro;

/**
 * This is the base interface for any LassoJavaModule
 *
 * <p>Upon Lasso startup, <code>registerLassoModule</code> method is called for 
 * every Java module located inside the LassoModules folder. Modules then return 
 * information about their names, implemented tags or datasources, main entry (method name), etc.
 * <p>
 * Datasource modules are instantiated only once and then used repeatedly to perform various datasource actions.
 * Substitution tag modules are instantiated every time Lasso resolves a tag implemented by a <code>LassoTagModule</code>
 */

public interface LassoJavaModule
	extends com.blueworld.lassopro.LassoJavaModule
{
	
}
