package com.omnipilot.lassopro;

/**
* Operator constants used throughout LJAPI
*/
public final class LassoOperators
{
	/** Field search operator <i>GT</i> */
	public static final int OP_GREATER_THAN			=	0x3E202020;	// '>   '
	/** Field search operator <i>GTE</i> */
	public static final int OP_GREATER_THAN_EQUALS	=	0x3E3D2020;	// '>=  '
	/** Field search operator <i>EQ</i> */
	public static final int OP_EQUALS				=	0x3D202020;	// '=   '
	/** Field search operator <i>LT</i> */
	public static final int OP_LESS_THAN			=	0x3C202020;	// '<   '
	/** Field search operator <i>LTE</i> */
	public static final int OP_LESS_THAN_EQUALS		=	0x3C3D2020;	// '<=  '
	/** Field search operator <i>BW</i> */
	public static final int OP_BEGINS_WITH			=	0x62677774;	// 'bgwt'
	/** Field search operator <i>EW</i> */
	public static final int OP_ENDS_WITH			=	0x656E6473;	// 'ends'
	/** Field search operator <i>CN</i> */
	public static final int OP_CONTAINS				=	0x636F6E74;	// 'cont'
	public static final int OP_NOT_CONTAINS			=	0x21637473;	// '!cts'
	public static final int OP_NOT_BEGINS_WITH		=	0x21626773;	// '!bgs'
	public static final int OP_NOT_ENDS_WITH		=	0x21656E64;	// '!end'
	/** Logical operator <i>AND</i> */
	public static final int OP_AND					=	0x414E4420;	// 'AND '
	/** Logical operator <i>OR</i> */
	public static final int OP_OR					=	0x4F522020;	// 'OR  '
	/** Logical operator <i>NOT</i> */
	public static final int OP_NOT					=	0x4E4F5420;	// 'NOT '
	/** Same as {@link #OP_NOT OP_NOT} */
	public static final int OP_NO					=	0x6E6F2020;	// 'no  '
	/** Specified by <i>-Random</i> database action */
	public static final int OP_ANY					=	0x616E7920;	// 'any '

	/** Field search operator <i>IN</i> */
	public static final int OP_IN_LIST  			= 	0x206E6C74;	// ' nlt',
	public static final int OP_NOT_IN_LIST  		= 	0x216E6C74;	// '!nlt',
	/** Field search operator <i>FT</i> */
	public static final int OP_IN_FULL_TEXT 		=	0x20667478;	// ' ftx',
	/** Field search operator <i>RX</i> */
	public static final int OP_IN_REGEXP  			= 	0x20727870;	// ' rxp',
	/** Field search operator <i>NRX</i> */
	public static final int OP_NOT_IN_REGEXP	 	= 	0x21727870;	// '!rxp'
	
	/** Same as {@link #OP_NOT OP_NOT} */
	public static final int OP_NOT_EQUALS = OP_NOT;
	/** Same as {@link #OP_BEGINS_WITH OP_BEGINS_WITH} */
	public static final int OP_DEFAULT = OP_BEGINS_WITH;
	
	private LassoOperators() {};

}