package com.omnipilot.lassopro;

/**
* These constants signify the different parameters which can be retrieved from
* the <code>LassoCall.getLassoParam</code> method.
* @see LassoCall#getLassoParam
*/
public class LassoParams
{
	/** path to LassoModules folder */ 
	public static final int ModulesFolderPath		= 0x4D507468; // 'MPth'
	/** relative path to LassoStartup folder */
	public static final int StartupItemsFolderPath	= 0x53507468; // 'SPth'
	/** relative path to errors log file */
	public static final int LassoErrorsFilePath		= 0x4C454650; // 'LEFP'
	//public static final int DataRootFolderPath		= 0x44524650; // 'DRFP'
	/** address of the Lasso MySQL host */
	public static final int StorageHost				= 0x53487374; // 'SHst'
	
	/** relative path to scripts root */
	public static final int ScriptsRoot				= 0x53526F74; // 'SRot'
	
	/** relative path to site scripts root (most likely includes ScriptsRoot) */
	public static final int ScriptsSiteRoot			= 0x53536974; // 'SSit'

	private LassoParams() {};
}