package com.omnipilot.lassopro;

/**
* These constants signify the different parameters which can be retrieved from
* the <code>LassoCall.getRequestParam</code> method.
* @see LassoCall#getRequestParam
*/
public class RequestParams
{
	
	/** All text in URL after the question mark */
	public static final int SearchArgKeyword 	= 0x6B666F72; // 'kfor'
	
	/** Username sent from browser */
	public static final int UserKeyword 		= 0x75736572; // 'user'
	
	/** Password sent from browser */
	public static final int PasswordKeyword 	= 0x70617373; // 'pass'
	
	/** IP address of client browser */
	public static final int AddressKeyword 		= 0x61646472; // 'addr'
	
	/** HTTP object body (form data, etc.) */
	public static final int PostKeyword 		= 0x706F7374; // 'post'
	
	/** GET or POST, depending on &lt;form method&gt; */
	public static final int MethodKeyword 		= 0x6D657468; // 'meth'
	
	/** IP address of server on which the Web server is running */
	public static final int ServerName 			= 0x73766E6D; // 'svnm'
	
	/** IP port this hit came to (80 is common, 443 for SSL) */
	public static final int ServerPort 			= 0x73767074; // 'svpt'
	
	/** Relative path from server root to this Lasso format file */
	public static final int ScriptName 			= 0x73636E6D; // 'scnm'
	
	/** MIME header sent from client browser */
	public static final int ContentType 		= 0x63747970; // 'ctyp'
	
	/** The length in bytes of the POST data sent from &lt;form POST&gt; */
	public static final int ContentLength 		= 0x434C656E; // 'CLen'
	
	/** URL of referring page */
	public static final int ReferrerKeyword 	= 0x72656672; // 'refr'
	
	/** Browser name and type */
	public static final int UserAgentKeyword 	= 0x41676E74; // 'Agnt'
	
	/** Type of HTTP request (GET, POST, etc.) */
	public static final int ActionKeyword		= 0x4B616374; // 'Kact'
	
	/** IP address of client browser */
	public static final int ClientIPAddress 	= 0x4B617074; // 'Kapt'
	
	/** All MIME headers, uninterpreted */
	public static final int FullRequestKeyword 	= 0x4B667271; // 'Kfrq'
	
	//since v7
	
	/** Client cookie data */
	public static final int CookiesKeyword 		= 0x6B6F6B79; // 'koky'
	
	public static final int IndexFile 			= 0x50697866; // 'Pixf'
	
	public static final int SessionRootPath		= 0x53507468; // 'SPth'
	
	public static final int SessionErrorFile	= 0x50657266; // 'Perf'
	
	public static final int SessionNoAccessFile	= 0x506E6166; // 'Pnaf'

	public static final int SessionLogFile		= 0x506C6766; // 'Plgf'
	
	public static final int SessionSiteName		= 0x53697465; // 'Site'

	public static final int GetUseLocalFiles	= 0x474C6F63; // 'GLoc'	
		
	private RequestParams() {;}
}