//
// NSLookup.java
//


package com.omnipilot.tags;


import com.omnipilot.lassopro.*;
import java.io.*;
import java.net.*;


public class NSLookup extends LassoTagModule
{	
	public int format( LassoCall lasso, int action )
	{
		int err = ERR_NOERR;
		
		try
		{
			IntValue count = new IntValue();		
			lasso.getTagParamCount(count);
			
			if ( count.intValue() == 1 )
			{
				LassoValue param = new LassoValue();		
				lasso.getTagParam(0, param);
				
				String result = getAddressOrName( param.name() );
				
				err = lasso.outputTagData( result );
			}
		}
		catch(IOException e)
		{
			lasso.setResultMessage( e.toString() );
			err = -1;
		}
		
		return err;
	}
	
	private static String getAddressOrName( String lookup ) throws IOException
	{
		InetAddress theAddress = InetAddress.getByName(lookup);
		boolean ip = true;
			
		for (int i = 0; i < lookup.length(); i++)
		{
			char c = lookup.charAt(i);
			if ( !Character.isDigit(c) )
			{
				if (c != '.')
				{
					ip = false;
					break;
				}
			}
		}
		
		return (ip) ? theAddress.getHostName() : theAddress.getHostAddress();
	}
	
	public void registerLassoModule()
	{
		registerTagModule( getClass().getName(), "", "nslookup", "format", FLAG_SUBSTITUTION, "Look up the domain" );
	}
	
}
