package com.omnipilot.util;

/**
* Base Lasso exception class
*/
public class LassoException extends Exception
{
	private static final int ERR_CODE = -1;
	
	/**
	* Constructs the object with the specified exception code
	*/
	public LassoException(int code)
	{
		super();
		resultCode = code;
	}

	/**
	* Constructs the object with the specified exception message
	*/
	public LassoException(String message)
	{
		super(message);
		resultCode = ERR_CODE;
	}
	
	/**
	* Constructs the object with the specified exception code and message
	*/
	public LassoException(Exception ex)
	{
		super(ex.getMessage());
		resultCode = ERR_CODE;
	}
	
	/**
	* Constructs the object with the specified exception code
	*/
	public LassoException(int code, String message)
	{
		super(message);
		resultCode = code;
	}
		
	/**
	* Returns the exception code 
	*/
	public final int getCode()
	{
		return resultCode;
	}
	
	protected int resultCode;
	protected int resultMessage;
}