<?LassoScript
//
// Store Search Variables in Session
//

session_addvar: -name='_reference', 'detail_maxrecords';
session_addvar: -name='_reference', 'detail_skiprecords';
session_addvar: -name='_reference', 'detail_found_count';
session_addvar: -name='_reference', 'detail_mode';
session_addvar: -name='_reference', 'detail_index';

variable_default: 'detail_mode', 'default';
variable_default: 'detail_skiprecords', 0;

//
// Base Inline
//

variable: 'detail_inline' = (array);

//
// Search Parameters
//

if: ($detail_mode >> 'search') && (var_defined: 'search_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $search_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'advanced') && (var_defined: 'advanced_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $advanced_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'browse_category') && (var_defined: 'browse_category_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $browse_category_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'browse_legacy') && (var_defined: 'browse_legacy_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $browse_legacy_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'list_category') && (var_defined: 'list_category_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $list_category_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'list_legacy') && (var_defined: 'list_legacy_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $list_legacy_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'list_all') && (var_defined: 'list_all_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $list_all_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'detail_related') && (var_defined: 'detail_index');
	variable: 'detail_inline' = $ref_tag_inline;
	$detail_inline->(insert: -search='');
	$detail_inline->(insert: -op='eq');
	$detail_inline->(insert: 'tag_id'=(var: 'detail_index'));
	$detail_skiprecords=0;
else;
	variable: 'detail_inline' = $ref_tag_inline;
	$detail_inline->(insert: -search='');
	$detail_inline->(insert: 'tag_basic'='Y');
	$detail_inline->(insert: -SortField='tag_name');
/if;

if: (var: 'detail_inline')->type != 'array';
	var: 'detail_inline' = $ref_tag_inline;
/if;

$detail_inline->(insert: -maxrecords=1);

//
// Navigation Parameters
//

if: (var_defined: 'detail_navigation') && (var_defined: 'detail_found_count') && (var_defined: 'detail_skiprecords') && (var_defined: 'detail_maxrecords');
	if: ($detail_navigation >> 'Prev');
		var: 'temp' = (math_min: $detail_found_count, (math_max: 0, (math_sub: $detail_skiprecords, $detail_maxrecords)));
		$detail_inline->(insert: -SkipRecords=$temp);
	else: ($detail_navigation >> 'Next');
		var: 'temp' = (math_min: $detail_found_count, (math_max: 0, (math_add: $detail_skiprecords, $detail_maxrecords)));
		$detail_inline->(insert: -SkipRecords=$temp);
	/if;
else;
	$detail_inline->(insert: -SkipRecords=$detail_skiprecords);
/if;

//
// Perform the Search
//

inline: -log=$__startup_loglevel__, $detail_inline, -inlinename='detail_results';
	var: 'detail_found_count' = (found_count);
	var: 'detail_shown_count' = (shown_count);
	var: 'detail_shown_first' = (shown_first);
	var: 'detail_shown_last' = (shown_last);
	var: 'detail_maxrecords' = (maxrecords_value);
	var: 'detail_skiprecords' = (skiprecords_value);
/inline;

?>
