<?LassoScript

//
// Store Search Variables in Session
//

session_addvar: -name='_reference', 'search_action';
session_addvar: -name='_reference', 'search_tag';
session_addvar: -name='_reference', 'search_category';
session_addvar: -name='_reference', 'search_type';
session_addvar: -name='_reference', 'search_set';
session_addvar: -name='_reference', 'search_support';

session_addvar: -name='_reference', 'search_sort';
session_addvar: -name='_reference', 'search_maxrecords';
session_addvar: -name='_reference', 'search_skiprecords';
session_addvar: -name='_reference', 'search_found_count';
session_addvar: -name='_reference', 'search_mode';
session_addvar: -name='_reference', 'search_inline';

//
// Define Default Variables
//

variable_default: 'search_action', 'Search';
variable_default: 'search_sort', 'Name';
variable_default: 'search_set', 'LDML8';

if: (var: 'search_mode') == 'Search';
	if: (action_param: 'search_tag') == '';
		var: 'search_tag'='';
	/if;
/if;

if: ($search_action == 'Clear');
	var: 'search_tag'='';
	var: 'search_category'='Any';
	var: 'search_type'='Any';
	var: 'search_set'='Any';
	var: 'search_support'='Any';
	var: 'search_sort'='Name';
	var: 'search_found_count'=0;
else: ($search_action == 'Quick');
	var: 'search_category'='Any';
	var: 'search_type'='Any';
	var: 'search_set'='LDML8';
	var: 'search_support'='Any';
	var: 'search_sort'='Name';
	var: 'search_found_count'=0;
/if;

if: (var_defined: 'search_mode');

	//
	// Base Inline
	//

	variable: 'search_inline' = $ref_tag_inline;

	//
	// Sorting Parameters
	//

	if: (var_defined: 'search_sort');
		if: ($search_sort >> 'Name');
			$search_inline->(insert: -SortField='tag_sort');
		else: ($search_sort >> 'Type');
			$search_inline->(insert: -SortField='tag_type');
			$search_inline->(insert: -SortField='tag_sort');
		else: ($search_sort >> 'Set');
			$search_inline->(insert: -SortField='tag_language');
			$search_inline->(insert: -SortField='tag_sort');
		else: ($search_sort >> 'Support');
			$search_inline->(insert: -SortField='tag_support');
			$search_inline->(insert: -SortField='tag_sort');
		/if;
	/if;

	//
	// Navigation Parameters
	//

	if: (var_defined: 'search_navigation') && (var_defined: 'search_found_count') && (var_defined: 'search_skiprecords') && (var_defined: 'search_maxrecords');
		if: ($search_navigation >> 'Prev');
			var: 'temp' = (math_min: $search_found_count, (math_max: 0, (math_sub: $search_skiprecords, $search_maxrecords)));
			$search_inline->(insert: -SkipRecords=$temp);
		else: ($search_navigation >> 'Next');
			var: 'temp' = (math_min: $search_found_count, (math_max: 0, (math_add: $search_skiprecords, $search_maxrecords)));
			$search_inline->(insert: -SkipRecords=$temp);
		/if;
	/if;

	//
	// Search Parameters
	//

	$search_inline->(insert: -search='');
	$search_inline->(insert: -maxrecords=15);
	$search_inline->(insert: -op='eq');
	$search_inline->(insert: 'tag_display'='Y');

	if: ($search_action == 'Search') || ($search_action == 'Quick');
		if: (var:'search_tag')!='';
			$search_inline->(insert: -op='cn');
			$search_inline->(insert: 'tag_name'=(var: 'search_tag'));
		/if;
		if: (var:'search_category')!='Any';
			$search_inline->(insert: 'tag_category'=(var: 'search_category'));
		/if;
		if: (var:'search_type')!='Any';
			$search_inline->(insert: 'tag_type'=(var: 'search_type'));
		/if;
		if: (var:'search_set')!='Any';
			$search_inline->(insert: -op='cn');
			$search_inline->(insert: 'tag_language'=(var: 'search_set'));
		/if;
		if: (var:'search_support')!='Any';
			$search_inline->(insert: 'tag_support'=(var: 'search_support'));
		/if;
	/if;

	//
	// Perform the Search
	//

	if: ($search_action != 'Clear');
		inline: -log=$__startup_loglevel__, $search_inline, -inlinename='search';
			var: 'search_found_count' = (found_count);
			var: 'search_shown_count' = (shown_count);
			var: 'search_shown_first' = (shown_first);
			var: 'search_shown_last' = (shown_last);
			var: 'search_maxrecords' = (maxrecords_value);
			var: 'search_skiprecords' = (skiprecords_value);
			
			if: (found_count == 1) && ($search_action == 'Quick');
				var: 'search_action' = 'Search';
				redirect_url: $admin_file + '?tab1=detail&tab2=tag&detail_mode=search&detail_skiprecords=0&detail_tag=' + (field:'tag_id');
			/if;
			
		/inline;
	/if;
/if;

// Reset Action
var: 'search_action'='Search';


?>
