<?LassoScript

//
// Store Search Variables in Session
//

session_addvar: -name='_reference', 'examplesearch_action';
session_addvar: -name='_reference', 'examplesearch_tag';
session_addvar: -name='_reference', 'examplesearch_title';
session_addvar: -name='_reference', 'examplesearch_description';
session_addvar: -name='_reference', 'examplesearch_example';
session_addvar: -name='_reference', 'examplesearch_result';

session_addvar: -name='_reference', 'examplesearch_sort';
session_addvar: -name='_reference', 'examplesearch_maxrecords';
session_addvar: -name='_reference', 'examplesearch_skiprecords';
session_addvar: -name='_reference', 'examplesearch_found_count';
session_addvar: -name='_reference', 'examplesearch_mode';
session_addvar: -name='_reference', 'examplesearch_inline';

//
// Define Default Variables
//

variable_default: 'examplesearch_action', 'Search';
variable_default: 'examplesearch_sort', 'Name';

if: (var: 'examplesearch_mode') == 'Search';
	if: (action_param: 'examplesearch_tag') == '';
		var: 'examplesearch_tag'='';
	/if;
	if: (action_param: 'examplesearch_description') == '';
		var: 'examplesearch_description'='';
	/if;
	if: (action_param: 'examplesearch_example') == '';
		var: 'examplesearch_example'='';
	/if;
	if: (action_param: 'examplesearch_result') == '';
		var: 'examplesearch_result'='';
	/if;
	if: (action_param: 'examplesearch_title') == '';
		var: 'examplesearch_title'='';
	/if;
/if;

if: ($examplesearch_action == 'Clear');
	var: 'examplesearch_title'='';
	var: 'examplesearch_description'='';
	var: 'examplesearch_example'='';
	var: 'examplesearch_result'='';
	var: 'examplesearch_tag'='';
	var: 'examplesearch_sort'='Tag';
	var: 'examplesearch_found_count'=0;
/if;

if: (var_defined: 'examplesearch_mode');

	//
	// Base Inline
	//

	variable: 'examplesearch_inline' = $ref_example_inline;

	//
	// Sorting Parameters
	//

	if: (var_defined: 'examplesearch_sort');
		if: ($examplesearch_sort >> 'Tag');
			$examplesearch_inline->(insert: -SortField='tag_name');
		else: ($examplesearch_sort >> 'Title');
			$examplesearch_inline->(insert: -SortField='ex_title');
		/if;
	/if;

	//
	// Navigation Parameters
	//

	if: (var_defined: 'examplesearch_navigation') && (var_defined: 'examplesearch_found_count') && (var_defined: 'examplesearch_skiprecords') && (var_defined: 'examplesearch_maxrecords');
		if: ($examplesearch_navigation >> 'Prev');
			var: 'temp' = (math_min: $examplesearch_found_count, (math_max: 0, (math_sub: $examplesearch_skiprecords, $examplesearch_maxrecords)));
			$examplesearch_inline->(insert: -SkipRecords=$temp);
		else: ($examplesearch_navigation >> 'Next');
			var: 'temp' = (math_min: $examplesearch_found_count, (math_max: 0, (math_add: $examplesearch_skiprecords, $examplesearch_maxrecords)));
			$examplesearch_inline->(insert: -SkipRecords=$temp);
		/if;
	/if;

	//
	// Search Parameters
	//

	$examplesearch_inline->(insert: -search='');
	$examplesearch_inline->(insert: -maxrecords=15);

	if: ($examplesearch_action == 'Search');
		if: (var:'examplesearch_title')!='';
			$examplesearch_inline->(insert: -op='cn');
			$examplesearch_inline->(insert: 'ex_title'=(var: 'examplesearch_title'));
		/if;
		if: (var:'examplesearch_description')!='';
			$examplesearch_inline->(insert: -op='cn');
			$examplesearch_inline->(insert: 'ex_description'=(var: 'examplesearch_description'));
		/if;
		if: (var:'examplesearch_example')!='';
			$examplesearch_inline->(insert: -op='cn');
			$examplesearch_inline->(insert: 'ex_example'=(example_search: (var: 'examplesearch_example')));
		/if;
		if: (var:'examplesearch_result')!='';
			$examplesearch_inline->(insert: -op='cn');
			$examplesearch_inline->(insert: 'ex_result'=(example_search: (var: 'examplesearch_result')));
		/if;
		if: (var:'examplesearch_tag')!='';
			$examplesearch_inline->(insert: -op='cn');
			$examplesearch_inline->(insert: 'tag_name'=(var: 'examplesearch_tag'));
		/if;
	/if;

	//
	// Perform the Search
	//
	if: ($examplesearch_action != 'Clear');
		inline: -log=$__startup_loglevel__, $examplesearch_inline, -inlinename='search';
			var: 'examplesearch_found_count' = (found_count);
			var: 'examplesearch_shown_count' = (shown_count);
			var: 'examplesearch_shown_first' = (shown_first);
			var: 'examplesearch_shown_last' = (shown_last);
			var: 'examplesearch_maxrecords' = (maxrecords_value);
			var: 'examplesearch_skiprecords' = (skiprecords_value);
		/inline;
	/if;
/if;

?>
