<?LassoScript
// This file sets up the environment in which the page will run.

// -----------
// sql queries

var:'__sql_statement__' = '';

var:'kAdminInfo' =
'select id,name,password from security_users where id = 2';

var:'kGlobalPrefs' = 'select * from global_prefs
where store_key in (\'lasso_install_date\',\'lasso_register_name\',\'lasso_register_org\',\'lasso_release_date\')';


// -----------
// global vars

var:'kPurchaseURL' = 'http://store.omnipilot.com/';


var:'db' = 'lasso_internal';
var:'err'= 0, 'err_msg'='';
var:'temp'='';

var:'login_serial' = action_param:'serial';
var:'login_serialnum'='';
var:'login_serialkey'='';
var:'prefs_map'=map;
var:'login_admin' = map;
var:'admin_map'=map;



// -----------
// global vars


var:'login_action'='';

if: action_param:'action' != null;
	$login_action = action_param:'action';
/if;

// are we going to display multiple serial numbers?
inline: -log=$__startup_loglevel__, -findall, -database=$db, -table='serial_numbers', -maxrecords=1;
	records;
		$login_serialnum = field:'serial';
		$login_serialkey = field:'id';
	/records;
/inline;


inline: -log=$__startup_loglevel__, -database=$db, -maxrecords=1, -sql=$kAdminInfo;
	$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
	if: !$err && found_count;
		loop:(field_name:-count);
			$admin_map->insert:(field_name:loop_count) = field:(field_name:loop_count);
		/loop;
	/if;
/inline;


inline: -log=$__startup_loglevel__, -database=$db, -sql=$kGlobalPrefs;
	$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
	if: !$err && found_count;
		records;
			$prefs_map->insert:(field:'store_key')=(field:'data');
		/records;
	/if;
/inline;

// dispatch
if: $login_action >> 'Update Username and Password';

	$login_admin->insert:'name' = (action_param:'username');
	$login_admin->insert:'password' = (encrypt_md5: (action_param:'password'));
	$login_admin->insert:'password_plain' = (action_param:'password');

	if: (action_param:'username') == '';

		$err = 1; $err_msg = 'Please enter Administrator login name';
		($login_admin->find:'name') = 'administrator';

	else: ($login_admin->find:'password') != ($admin_map->find:'password');

		$err = 3; $err_msg = 'Incorrect password';

	else: (action_param:'password_new') == null || (action_param:'password_confirm') == null;

		$err = 2; $err_msg = 'New password must be non-empty.';

	else: (action_param:'password_new') != null && (action_param:'password_confirm') != null &&
		  ((action_param:'password_new') != (action_param:'password_confirm'));

		$err = 2; $err_msg = 'New password and confirmation password do not match';

	else;

		$login_admin->insert:'password_new' = (encrypt_md5: (action_param:'password_new'));

	/if;

	if: !$err && ($admin_map->find:'id');
		inline: -log=$__startup_loglevel__, -database=$db, -sql='update security_users set name=\'' + ($login_admin->find:'name') +
			'\', password=\'' + $login_admin->(find:'password_new') + '\', password_plain=\'' + $login_admin->(find:'password_plain') + '\' where id=' + ($admin_map->find:'id');
			$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
			if: !$err;
				($admin_map->find:'name') = ($login_admin->find:'name');
				_security_flushcaches;
			/if;
		/inline;

		redirect_url: (response_filepath);

	/if;


else: $login_action >> 'Update Serial';

	if: $login_serial == $login_serialnum;
		$err = 0; $err_msg = 'Serial number unchanged';
	else: ($login_serial == null) || ($login_serial >> '*');
		$err = 5; $err_msg = 'Please enter serial number, then try again.';
	else: !( ($login_serial >> 'LP8') || ($login_serial >> 'LS8') );
		$err = 6; $err_msg = 'Please double check your serial number, then try again.';
	else;
		inline: -log=$__startup_loglevel__, -update, -database=$db, -table='serial_numbers', -keyfield='id', -keyvalue=$login_serialkey, 'id'='1','serial'=$login_serial;
			$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
			if: ($err_msg == error_noerror) && (_security_isserialized == true);
				$err = 0;	// fix for err -9985 bug
				$login_serialnum = $login_serial;
			else;
				$err = 7; $err_msg = 'Please double check your serial number, then try again.';
				inline: -log=$__startup_loglevel__, -update, -database=$db, -table='serial_numbers', -keyfield='id', -keyvalue=$login_serialkey, 'serial'=$login_serialnum;
				/inline;
			/if;
		/inline;
	/if;

else: $login_action >> 'Purchase Lasso';

	redirect_url: $kPurchaseURL;

/if;


// Reset global admin serial number if the serial number has changed.
if: (var_defined:'admin_serialnum') == false || (var: 'login_serialnum') != (var:'admin_serialnum');
	var: 'admin_serialnum' = $login_serialnum;

	// Parse $admin_serialnum
	if: ($admin_serialnum >> 'LS8GL') || ($admin_serialnum >> 'LS8DW') || ($admin_serialnum >> 'LP8-DEV');
	  var: 'admin_serialedition'='Single-User';
	else: ($admin_serialnum >> 'LP8-WIN') || ($admin_serialnum >> 'LP8-MAC') || ($admin_serialnum >> 'LP8-LIN');
	  var: 'admin_serialedition'='Multi-User';
	else;
	  var: 'admin_serialtemp'=(_security_serialexpiration);
	  if: (var: 'admin_serialtemp') != '';
		  var: 'admin_serialedition'='Evaluation (Expires ' + $admin_serialtemp + ')';
	  else;
		  var: 'admin_serialedition'='Unknown Edition';
	  /if;
	/if;
/if;

// Obscure Password
$admin_map->insert:'password'='********';

// Obscure Serial Number
var: 'admin_serialdisplay' = $admin_serialnum;
if: $admin_serialdisplay->size > 4;
	$admin_serialdisplay = $admin_serialdisplay->(substring: 1, $admin_serialdisplay->size - 4);
	$admin_serialdisplay += '****';
/if;

?>
