<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<?LassoScript

	if: !(global_defined: '__startup_loglevel__');
		global: '__startup_loglevel__' = 'none';
	/if;

	var: 'security_token' = 'site_admin';

	auth_admin: -realm='Lasso Site ' + lasso_siteid + ' Admin', -NoResponse;

	if: (action_param: 'action') >> 'refresh';
		_security_flushcaches;
		'<!-- Flush Caches ' + lasso_siteid + ' -->';
	/if;

	include: (lassoapp_link: 'tags.lasso');
	_admin_nocache;

	admin_setpref: 'lasso_site_admin_url', 'http://' + server_name + ':' + server_port + response_filepath;

	// Initialize
	if: ((admin_getpref: 'lasso_site_initialized') !>> 'Y') || ((action_param: 'initialize') >> 'initialize');

		include: (lassoapp_link: 'initialize/library.lasso');
		include: (lassoapp_link: 'initialize/default.lasso');
		
	else;

		include: (lassoapp_link: 'library.lasso');	

?>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" >
	<head>
		<title>[var: 'admin_title', -encodenone]</title>
		<style>[include: (lassoapp_link: 'default_css.lasso')]</style>

		<script language="JavaScript">
			function showhelp(url)
			{
				window.open(url,'help','status=no,menubar=no,scrollbars=yes,resizable=yes,width=472,height=356');
				return false;
			}
		</script>

	<?LassoScript

		// This variable holds the default tab for each section
		_admin_addvar: -name='admin_memory', -session='_siteadmin', -default=(map);

		// Library One

		If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_memory->(find: '_root');
		/If;
		If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_tab_array1->(get:1)->first;
		/If;
		$admin_memory->(insert: '_root' = $admin_tab1);

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/library.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Library Two

		If: ($admin_tab2 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2) == 'None';
			variable: 'admin_tab2' = $admin_memory->(find: $admin_tab1);
		/If;
		If: ($admin_tab2 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2) == 'None';
			variable: 'admin_tab2' = (_admin_array_find: $admin_tab_array2, $admin_tab1)->(get:1)->first;
		/If;
		$admin_memory->(insert: $admin_tab1 = $admin_tab2);

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/library.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Library Three

		If: ($admin_tab3 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3) == 'None';
			variable: 'admin_tab3' = $admin_memory->(find: $admin_tab1 + ':' + $admin_tab2);
		/If;
		If: ($admin_tab3 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3) == 'None';
			variable: 'admin_tab3' = (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2)->(get:1)->first;
		/If;
		$admin_memory->(insert: ($admin_tab1 + ':' + $admin_tab2) = $admin_tab3);

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/' + $admin_tab3 + '/library.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Reset admin_link based on actual tab visited

		var: 'admin_link' = $admin_file +
			'?tab1=' + $admin_tab1 +
			'&tab2=' + $admin_tab2 +
			'&tab3=' + $admin_tab3 +
			'&-session=_admin:' + (session_id: -name='_siteadmin') +
			'&increment=' + $admin_increment;
	?>

	[if: ((var: 'admin_refresh') == true)]
		<meta http-equiv="refresh" content="60; url=[var: 'admin_link', -encodenone]">
	[/if]

	</head>

		<div id="frame_main" class="frame_main">

[if: (client_type >> 'MSIE') && (client_type >> 'Mac_PowerPC')]
			<div id="header_tab1" align="center">
				<img class="graphic_left" src="[lassoapp_link:'images/logo_left.jpg']" alt="" width="144" height="36" />
				<a href="http://www.omnipilot.com" target="_new"><img class="graphic_right" src="[lassoapp_link:'images/logo_right.jpg']" alt="" width="144" height="36" border=0 /></a>[loop: $admin_tab_array1->size][var: 'temp' = $admin_tab_array1->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $temp->First]" class="tab1[If: $temp->First == $admin_tab1] active1[/If]"><img class="corner_left1" src="[lassoapp_link:'images/blank.gif']" border="0" alt="" width="1" height="1" />&nbsp;&nbsp;&nbsp;[encode_html: $temp->Second]&nbsp;&nbsp;&nbsp;<img class="corner_right1" src="[lassoapp_link:'images/blank.gif']" border="0" alt="" width="1" height="1" /></a>[/loop]
			</div>
[Variable: 'temp_array' = (_admin_array_find: $admin_tab_array2, $admin_tab1)]
			<div id="header_tab2">[Iterate: $temp_array, (Variable: 'temp')]
				<a href="[Response_FilePath]?tab1=[encode_url: $admin_tab1]&tab2=[encode_url: $temp->First]" class="tab2[If: $temp->First == $admin_tab2] active2[/If]"><img class="corner_left2" src="images/1x1.gif" border="0" alt="" width="1" height="1" />&nbsp;&nbsp;&nbsp;[encode_html: $temp->Second]&nbsp;&nbsp;&nbsp;<img class="corner_right2" src="images/1x1.gif" border="0" alt="" width="1" height="1" /></a>[/Iterate]
			</div>
[Variable: 'temp_array' = (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2)]
			<div id="header_tab3">[Iterate: $temp_array, (Variable: 'temp')]
				<a href="[Response_FilePath]?tab1=[encode_url: $admin_tab1]&tab2=[encode_url: $admin_tab2]&tab3=[encode_url: $temp->First]" class="tab3[If: $temp->First == $admin_tab3] active3[/If]"><img class="corner_left3" src="images/1x1.gif" border="0" alt="" width="1" height="1" />&nbsp;&nbsp;&nbsp;[encode_html: $temp->Second]&nbsp;&nbsp;&nbsp;<img class="corner_right3" src="images/1x1.gif" border="0" alt="" width="1" height="1" /></a>[/Iterate]
			</div>
[else]
			<div id="header_tab1" class="header_tab1" align="center">
				<img class="graphic_left" src="[lassoapp_link:'images/logo_left.jpg']" alt="" width="144" height="36" />
				<a href="http://www.omnipilot.com" target="_new"><img class="graphic_right" src="[lassoapp_link:'images/logo_right.jpg']" alt="" width="144" height="36" border=0 /></a>[loop: $admin_tab_array1->size][var: 'temp' = $admin_tab_array1->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $temp->First]" class="tab1[If: $temp->First == $admin_tab1] active1[/If]"><img class="corner_left1" src="[lassoapp_link:'images/corner_ffffff_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab1">[encode_html: $temp->Second]</span><img class="corner_right1" src="[lassoapp_link:'images/corner_ffffff_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[Variable: 'temp_array' = (_admin_array_find: $admin_tab_array2, $admin_tab1)]
			<div id="header_tab2" class="header_tab2">[loop: $temp_array->size][var: 'temp' = $temp_array->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $admin_tab1]&tab2=[encode_url: $temp->First]" class="tab2[If: $temp->First == $admin_tab2] active2[/If]"><img class="corner_left2" src="[lassoapp_link:'images/corner_999999_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab2">[encode_html: $temp->Second]</span><img class="corner_right2" src="[lassoapp_link:'images/corner_999999_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[Variable: 'temp_array' = (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2)]
			<div id="header_tab3" class="header_tab3">[loop: $temp_array->size][var: 'temp' = $temp_array->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $admin_tab1]&tab2=[encode_url: $admin_tab2]&tab3=[encode_url: $temp->First]" class="tab3[If: $temp->First == $admin_tab3] active3[/If]"><img class="corner_left3" src="[lassoapp_link:'images/corner_cccccc_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab3">[encode_html: $temp->Second]</span><img class="corner_right3" src="[lassoapp_link:'images/corner_cccccc_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[/if]

	<?LassoScript

		// Default One

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Default Two

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Default Three

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/' + $admin_tab3 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

	?>

			<div id="frame_footer" class="frame_footer">
				<table style="margin:0px">
					<tr>
						<th width="36"><a href="[var: 'admin_link']&action=refresh">Refresh</a></th>
						<td align="center">Site [lasso_sitename] ([lasso_siteid]) &#149; User [Var: 'admin_username'][if: ($admin_expires != '')] &#149; Build Expires [var: 'admin_expires'][/if]</td>
						<th width="36"><a href="[response_filepath]?logout=true">Logout</a></th>
					</tr>
				</table>
			</div>

		</div>
		<p>&copy; 1996[if: date->year > 1996]-[date->year][/if] OmniPilot Software, Inc.</p>

	</body>
</html>
<?LassoScript
	/if;	// Initialization
?>
