<?LassoScript

var: 'admin_refresh' = true;

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

_admin_addvar: 'email_status', -session='_siteadmin', -default='queued', -override=(action_param: 'email_status');
_admin_addvar: 'email_action', -default='None', -override=(action_param: 'email_action');

_admin_addvar: 'email_id', -default='', -override=(action_param: 'email_id');

_admin_addvar: 'email_skip', -default=0, -session='_siteadmin', -override=(action_param: 'email_skip');
_admin_addvar: 'email_max', -default=25;
_admin_addvar: 'email_navigation', -override=(action_param: 'email_navigation');
_admin_addvar: 'email_jump', -override=(action_param: 'email_jump');
_admin_addvar: 'email_found', -override=(action_param: 'email_found');

_admin_addvar: 'email_sortfield', -default='id', -session='_siteadmin', -override=(action_param: 'email_sortfield');
_admin_addvar: 'email_sortorder', -default='descending', -session='_siteadmin', -override=(action_param: 'email_sortorder');

_admin_addvar: 'email_oldstatus', -session='_siteadmin', -override=(action_param: 'email_oldstatus');
if: ($email_oldstatus == '') || ($email_oldstatus != $email_status);
	var: 'email_skip' = 0;
/if;

var: 'email_skip' = (integer: $email_skip);
var: 'email_max' = (integer: $email_max);
var: 'email_found' = (integer: $email_found);

if: ($email_navigation >> 'Next');
	$email_skip = (integer: ($email_skip + $email_max));
else: ($email_navigation >> 'Prev');
	$email_skip = (integer: (math_max: $email_skip - $email_max, 0));
else: ($email_navigation >> 'Last');
	$email_skip = $email_found->size - (($email_found->size - 1) % $email_max);
else: ($email_navigation >> 'First') || ($email_navigation >> 'Sort');
	$email_skip = 0;
else: ($email_navigation >> 'Jump') || ((action_param: 'email_navigation_skip') != '');
	$email_skip = (math_max: (integer: (action_param: 'email_navigation_skip')) - 1, 0);
/if;

if: ($email_skip > 0) && ($email_found > 0);
	$email_skip = (math_max: (math_min: $email_found - 1, $email_skip), 0);
/if;


var: 'email_inline' = (array);

$email_inline->(insert: -search='action');
$email_inline->(insert: -database='site');
$email_inline->(insert: -table='smtp_queue');

$email_inline->(insert: -maxrecords=$email_max);
$email_inline->(insert: -skiprecords=$email_skip);

$email_inline->(insert: -sortfield=$email_sortfield);
$email_inline->(insert: -sortorder=$email_sortorder);

if: ($email_status >> 'all');

	// Nothing
	
else: ($email_status >> 'queued');

	$email_inline->(insert: -op='eq');
	$email_inline->(insert: 'queue_status'='queued');

else: $email_status >> 'sent';

	$email_inline->(insert: -op='eq');
	$email_inline->(insert: 'queue_status'='sent');

else: $email_status >> 'error';

	$email_inline->(insert: -op='eq');
	$email_inline->(insert: 'queue_status'='error');

else: $email_status >> 'delete';

	$email_inline->(insert: -op='eq');
	$email_inline->(insert: 'queue_status'='delete');

/if;

if: ($dialog_action >> 'Delete') && ($dialog_action >> 'Error');

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_queue WHERE queue_status = "error"';
	/inline;

else: ($dialog_action >> 'Delete') && ($dialog_action >> 'Sent');

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_queue WHERE queue_status = "sent"';
	/inline;

else: ($dialog_action >> 'Delete') && ($dialog_action >> 'Queued');

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_queue WHERE queue_status = "queued"';
	/inline;

else: $dialog_action >> 'Delete All';

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM smtp_queue';
	/inline;

else: $email_action >> 'Stop';

	global: '__SMTP_Status__'='Pause';
	admin_setpref: 'lasso_smtp_pause' = 'Y';

else: $email_action >> 'Resume';

	global: '__SMTP_Status__'='Active';
	admin_setpref: 'lasso_smtp_pause' = 'N';

else: $email_action >> 'Delete';

	if: $email_id > 0;
		inline: -log=$__startup_loglevel__,
				-delete,
				-database='site',
				-table='smtp_queue',
				-keyfield='id',
				-keyvalue=$email_id;
		/inline;
	/if;

else: $email_action >> 'Try' && $email_action >> 'Now';

	inline: -log=$__startup_loglevel__, -database='site',
			-sql='UPDATE smtp_queue SET queue_date="' + date->(format: '%Q %T') + '" WHERE queue_status = "queued"';
	/inline;
	if: ((global: '__SMTP_Status__') !>> 'Pause');
		global: '__SMTP_Status__'='Active';
	/if;

else: $email_action >> 'Try';

	if: $email_id > 0;
		inline: -log=$__startup_loglevel__,
				-update,
				-database='site',
				-table='smtp_queue',
				-keyfield='id',
				-keyvalue=$email_id,
				'queue_date' = date->(format: '%Q %T');
		/inline;
		if: ((global: '__SMTP_Status__') !>> 'Pause');
			global: '__SMTP_Status__'='Active';
		/if;
	/if;
	
else: $email_action >> 'Requeue All';

	inline: -log=$__startup_loglevel__, -database='site',
			-sql='UPDATE smtp_queue SET queue_status="queued",queue_error="",queue_retries=0,queue_number=0,queue_date="' + date->(format: '%Q %T') + '" WHERE queue_status = "error"';
	/inline;
	if: ((global: '__SMTP_Status__') !>> 'Pause');
		global: '__SMTP_Status__'='Active';
	/if;

else: $email_action >> 'Requeue';

	if: $email_id > 0;
		inline: -log=$__startup_loglevel__,
				-update,
				-database='site',
				-table='smtp_queue',
				-keyfield='id',
				-keyvalue=$email_id,
				'queue_status' = 'queued',
				'queue_error' = '',
				'queue_retries' = 0,
				'queue_number' = 0,
				'queue_date' = date->(format: '%Q %T');
		/inline;
		if: ((global: '__SMTP_Status__') !>> 'Pause');
			global: '__SMTP_Status__'='Active';
		/if;
	/if;

/if;

?>