<?LassoScript

namespace_using('compare_');

	define_tag('lessThan', -required='lhs', -required='rhs');
		if(#lhs < #rhs);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('greaterThan', -required='lhs', -required='rhs');
		if(#lhs > #rhs);
			return(0);
		/if;
		return(-1);
	/define_tag;
	
	define_tag('contains', -required='lhs', -required='rhs');
		if(#lhs >> #rhs);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('notContains', -required='lhs', -required='rhs');
		if(#lhs !>> #rhs);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('equalTo', -required='lhs', -required='rhs');
		if(#lhs == #rhs);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('notEqualTo', -required='lhs', -required='rhs');
		if(#lhs != #rhs);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('strictEqualTo', -required='lhs', -required='rhs');
		if(#lhs === #rhs);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('strictNotEqualTo', -required='lhs', -required='rhs');
		if(#lhs !== #rhs);
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('beginsWith', -required='lhs', -required='rhs');
		if(#lhs->beginsWith(#rhs));
			return(0);
		/if;
		return(1);
	/define_tag;
	
	define_tag('endsWith', -required='lhs', -required='rhs');
		if(#lhs->endsWith(#rhs));
			return(0);
		/if;
		return(1);
	/define_tag;

/namespace_using;

namespace_using('match_');

	define_type('Regexp');
		local('exp'='');
		define_tag('onCreate', -required='exp');
			self->exp = #exp;
		/define_tag;
		define_tag('onCompare', -required='rhs');
			if(string_findregexp(-find=self->exp, #rhs)->size > 0);
				return(0);
			/if;
			return(1);
		/define_tag;
	/define_type;
	
	define_type('NotRegexp');
		local('exp'='');
		define_tag('onCreate', -required='exp');
			self->exp = #exp;
		/define_tag;
		define_tag('onCompare', -required='rhs');
			if(!(string_findregexp(-find=self->exp, #rhs)->size > 0));
				return(0);
			/if;
			return(1);
		/define_tag;
	/define_type;
	
	define_type('Range');
		local('low'='', 'high'='');
		define_tag('onCreate', -required='low', -required='high');
			self->low = #low;
			self->high = #high;
		/define_tag;
		define_tag('onCompare', -required='rhs');
			if(#rhs >= self->low && #rhs <= self->high);
				return(0);
			/if;
			return(1);
		/define_tag;
	/define_type;
	
	define_type('NotRange');
		local('low'='', 'high'='');
		define_tag('onCreate', -required='low', -required='high');
			self->low = #low;
			self->high = #high;
		/define_tag;
		define_tag('onCompare', -required='rhs');
			if(!(#rhs >= self->low && #rhs <= self->high));
				return(0);
			/if;
			return(1);
		/define_tag;
	/define_type;
	
	define_type('Comparator');
		local('cmp'='');
		local('lhs'=null);
		local('rhs'=null);
		define_tag('onCreate', -req='cmp', -opt='lhs', -opt='rhs');
			self->cmp = @#cmp;
			if (local_defined('lhs'));
				self->lhs = @#lhs;
			/if;
			if (local_defined('rhs'));
				self->rhs = @#rhs;
			/if;
		/define_tag;
		define_tag('onCompare', -required='somehs');
			if (self->rhs != null);
				return( self->cmp->invoke(#somehs, self->rhs));
			else;
				return( self->cmp->invoke(self->lhs, #somehs));
			/if;
		/define_tag;
	/define_type;

/namespace_using;

define_type('series', 'array', -description='Represents a series of values. Two parameters are required to construct a series type: -from and -to. \
									-from and -to are tested based on equality using the == operator and -from is advanced using the prefix ++ operator. \
									-from and -to need not be integers, but they must logically support the required == and ++ operators so that, eventually, -from will be equal to -to based on the application of the prefix ++ operator. \
									The ->size member indicates the total number of values in the series and the ->get member allows random access into the sequence of values. \
									The ->iterator and ->reverseiterator tags will return an iterator for the series.' );

	define_tag('onCreate', -required='from', -copy, -required='to');
		self->removeall;
		self->insert(#from);
		while(#from != #to);
			self->insert(++#from);		
		/while;
	/define_tag;
	
/define_type;

?>