<?LassoScript

namespace_using:'namespace_';
    
	define_constant('delimiter', '_');
    define_constant('global', '_global_');
    define_constant('page', '_page_');
    define_constant('current', '_current_');

	define_tag('fullPathExists', -namespace='_global_namespace_file_', -req='path', -privileged);
	
		// there are two allowed roots
		// this given path is going to be in one of them
		// we are not permitted to check any directories above either of these
		// so we need to determine which root is being looked in and start from there
		local('globalRoot' = admin_lassoservicepath + '/LassoLibraries/');
		local('localRoot' = admin_lassoservicepath + '/../../LassoLibraries/');
	
		if (#path->beginsWith(#globalRoot));
			local('madePath' = #globalRoot);
		else (#path->beginsWith(#localRoot));
			local('madePath' = #localRoot);
		else;
			return(false);
		/if;
		local('adjustedPath' = #path - #madePath);
		local('splt1' = #adjustedPath->split('/')->removeAll('') &);
		local('last' = #splt1->last);
		#splt1->remove;
		
		local('splt'=array);
		iterate(#splt1, local('i'));
			if (#i == '..');
				#splt->remove;
			else;
				#splt->insert(#i);
			/if;
		/iterate;
		
		// check all leading directory names
		iterate(#splt, local('i'));
			#i += '/';
			local('tstPath' = #madePath + #i);
			if (true);//!_global_file_exists(#tstPath)); // look harder
				local('list' = file_listdirectory(#madePath));
				local('fnd' = #list->find(#i));
				if (#fnd->size == 0);
					return(false);
				/if;
				#i = #fnd->first;
			/if;
			#madePath += #i;
		/iterate;
		// check the file name
		if (true);//!_global_file_exists(#madePath + #last));
			local('list' = file_listdirectory(#madePath));
			local('fnd' = #list->find(#last));
			if (#fnd->size == 0);
				return(false);
			/if;
			#madePath += #fnd->first;		
		else;
			#madePath += #last;	
		/if;
		#path = #madePath;
		return(true);
	/define_tag;

	define_tag:'load', -required='namespace', -privileged;	
		// transform namespace into a path
		// replace underscores with slashes
		local:'localPath' = admin_lassoservicepath + '/LassoLibraries/' + string_replace(-find='_', -replace='/', #namespace);
		#localPath->removeTrailing('/');
		
		local:'globalPath' = admin_lassoservicepath + '/../../LassoLibraries/' + string_replace(-find='_', -replace='/', #namespace);
		#globalPath->removeTrailing('/');
		
		local:'dotLassoLocalPath' = #localPath + '.lasso';
		local:'dotLassoAppLocalPath' = #localPath + '.LassoApp';
		local:'dotLassoGlobalPath' = #globalPath + '.lasso';
		local:'dotLassoAppGlobalPath' = #globalPath + '.LassoApp';
		
		local:'pathToUse'='';
		local:'processor'=null;
		
		if: _global_namespace_file_fullPathExists:#dotLassoLocalPath;
			#pathToUse = #dotLassoLocalPath;
			#processor = \process;
		else if: _global_namespace_file_fullPathExists:#dotLassoAppLocalPath;
			#pathToUse = #dotLassoAppLocalPath;
			#processor = \lassoapp_process;
		else if: _global_namespace_file_fullPathExists:#dotLassoGlobalPath;
			#pathToUse = #dotLassoGlobalPath;
			#processor = \process;
		else if: _global_namespace_file_fullPathExists:#dotLassoAppGlobalPath;
			#pathToUse = #dotLassoAppGlobalPath;
			#processor = \lassoapp_process;
		else;
			return:false;		
		/if;
	
		if:!var('_namespace_loader_active')->isa('set');
			var:'_namespace_loader_active' = set;
		/if;
		if:$_namespace_loader_active >> #namespace;
			log_detail('Namespace is already being loaded.');
			return:false;
		/if;
	
		$_namespace_loader_active->insert(#namespace);
		log_detail:'Attempting to load on-demand library ' #pathToUse ' for namespace ' #namespace;
		namespace_using: namespace_global + #namespace;
			protect;
				#processor->invoke(file_read:#pathToUse, -name=#pathToUse);
				log_detail:'Sucessfully loaded on-demand library ' #pathToUse ' for namespace ' #namespace;
				handle_error;
					log_critical:'Error while loading on-demand library ' 
						#pathToUse ' for namespace ' #namespace ': ' error_code ' ' error_msg;
				/handle_error;
			/protect;
		/namespace_using;
		$_namespace_loader_active->remove(#namespace);
		return:true;
	/define_tag;

/namespace_using;

?>